// Extension Preferences Menu
// Author: Antonius32
// Version 2.13.5 (February 2016)

var ExtensionPreferencesMenu = {
	startup: function() {
		window.removeEventListener('load', function EPMload() { ExtensionPreferencesMenu.startup() });

		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.addAddonListener(this);

		Components.utils.import("resource://gre/modules/Services.jsm");
		this._branch = Services.prefs.getBranch("extensions.ExtensionPreferencesMenu.");
		this._branch.addObserver("", this, false);

		window.addEventListener('customizationchange', function EPMsetup() { ExtensionPreferencesMenu.setup() });

		if (this._branch.getBoolPref("FirstRun"))
			this.onFirstRun();

		this.setup();
	},

	observe: function(aSubject, aTopic, aData) {
		if (aTopic == "nsPref:changed")
			this.setup();
	},

	onFirstRun: function() {
		this._branch.setBoolPref("FirstRun", false);

		// Pale Moon
		let navbar = document.getElementById("nav-bar");
		if (navbar) {
			// Install the toolbar button
			let downloadsbutton = document.getElementById("downloads-button");
			if (navbar.contains(downloadsbutton))
				navbar.insertItem("extensionPrefsMenu-button", downloadsbutton.nextSibling);
			else
				navbar.insertItem("extensionPrefsMenu-button");

			navbar.setAttribute("currentset", navbar.currentSet);
			document.persist("nav-bar", "currentset");

			// Make sure the Navigation toolbar is visible
			if (navbar.collapsed) {
				navbar.collapsed = false;
				document.persist("nav-bar", "collapsed");
			}
		}

		// FossaMail
		let mailtoolbar = document.getElementById("mail-bar3");
		if (mailtoolbar) {
			// Install the toolbar button
			let globalsearchbox = document.getElementById("gloda-search");
			if (mailtoolbar.contains(globalsearchbox))
				mailtoolbar.insertItem("extensionPrefsMenu-button", globalsearchbox.nextSibling);
			else
				mailtoolbar.insertItem("extensionPrefsMenu-button");

			mailtoolbar.setAttribute("currentset", mailtoolbar.currentSet);
			document.persist("mail-bar3", "currentset");

			// Make sure the Mail toolbar is visible
			if (mailtoolbar.collapsed) {
				mailtoolbar.collapsed = false;
				document.persist("mail-bar3", "collapsed");
			}
		}
	},

	setup: function() {
		let EPMAppmenu = document.getElementById("appmenu_extensionPrefs");
		EPMAppmenu.collapsed = !Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.InAppMenu");
		let EPMorigAddonMenu = document.getElementById("appmenu_addons");
		EPMorigAddonMenu.collapsed = !EPMAppmenu.collapsed;

		this.populate(EPMAppmenu.firstChild);

		let EPMToolsmenu = document.getElementById("extensionPrefsMenu");
		EPMToolsmenu.collapsed = !Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.InToolsMenu");
		// Pale Moon
		let EPMorigAddonMenuPM = document.getElementById("menu_openAddons");
		if (EPMorigAddonMenuPM)
			EPMorigAddonMenuPM.collapsed = !EPMToolsmenu.collapsed;
		// FossaMail
		let EPMorigAddonMenuFM = document.getElementById("addonsManager");
		if (EPMorigAddonMenuFM)
			EPMorigAddonMenuFM.collapsed = !EPMToolsmenu.collapsed;

		if (Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.IconInToolsMenu"))
			EPMToolsmenu.setAttribute("iconic", "true");
		else
			EPMToolsmenu.removeAttribute("iconic");

		this.populate(EPMToolsmenu.firstChild);

		let EPMToolbarButton = document.getElementById("extensionPrefsMenu-button");
		if (EPMToolbarButton)
			this.populate(EPMToolbarButton.firstChild);
	},

	populate: function(aParent) {
		let item, MenuIconURL, EPMShowIt = true, EPMBlackListArray = [];
		let EPMshowVersion = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ShowVersion");
		let EPMshowIcons = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ShowIcons");
		let EPMshowAll = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ShowAll");
		let EPMshowDisabled = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ShowDisabled");
		let EPMshowIncompatible = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ShowIncompatible");
		let EPMquickActions = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.QuickActions");
		let EPMShowRestart = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ShowRestart");
		let EPMrestartLabel = document.getElementById("EPMstring-bundle").getString("EPMRestart");
		let EPMopenApp = window['BrowserOpenAddonsMgr'] || window['openAddonsMgr'] || window['toEM']; 
		let EPMscrollInToView = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.ScrollInToView");
		let EPMhideSigned = Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.HideSigned");
		let EPMBlackList = Services.prefs.getCharPref("extensions.ExtensionPreferencesMenu.BlackList");
		if (EPMBlackList) {
			EPMBlackList = EPMBlackList.split("").reverse().join("");
			EPMBlackListArray = EPMBlackList.split(/\,(?!\\)/);
			for (let i = 0; i < EPMBlackListArray.length; i++)
				EPMBlackListArray[i] = EPMBlackListArray[i].split("").reverse().join("").replace(/^ | $/g,"").replace(/\\\,/g,",").toLowerCase();
		}

		AddonManager.getAllAddons(function(addon) {
			while (aParent.childNodes.length)
				aParent.removeChild(aParent.firstChild);

			addon.forEach(function(EPMaddon) {
				if (EPMaddon.type == "extension" && (!EPMaddon.appDisabled || (EPMaddon.appDisabled && EPMshowIncompatible)) && ((EPMaddon.isActive && EPMaddon.optionsURL) || ((EPMaddon.userDisabled && EPMshowDisabled) || (!EPMaddon.userDisabled && EPMshowAll) || (EPMaddon.appDisabled && EPMshowIncompatible)))) {
					item = document.createElement("menuitem");
					item.setAttribute("label", EPMshowVersion ? EPMaddon.name + "  " + (EPMhideSigned ? EPMaddon.version.replace(".1-signed", ".1") : EPMaddon.version) : EPMaddon.name);
					if (EPMaddon.description)
						item.setAttribute("tooltiptext", EPMaddon.description);
					item.addEventListener("command", function(event) {
						if (EPMaddon.optionsURL && !event.ctrlKey) {
							switch (Number(EPMaddon.optionsType)) {
								case 2:
									EPMopenApp('addons://detail/' + encodeURIComponent(EPMaddon.id) + (EPMscrollInToView ? '/preferences' : ''));
									break;
								case 3:
									"switchToTabHavingURI" in window ? switchToTabHavingURI(EPMaddon.optionsURL, true) : openTab("contentTab", { contentPage: EPMaddon.optionsURL });
									break;
								default:
									openDialog(EPMaddon.optionsURL, EPMaddon.name, 'chrome,titlebar,toolbar,resizable,scrollbars,centerscreen,dialog=no,modal=no');
								}
							let EPMpanelPopup = document.getElementById('PanelUI-popup');
							if (EPMpanelPopup)
								if (EPMpanelPopup.state == 'open')
									EPMpanelPopup.hidePopup(); 
						}
					});
					item.addEventListener("click", function(event) {
						if (EPMquickActions) {
							if (event.button == 1 && EPMaddon.homepageURL)
								"gBrowser" in window ? gBrowser.addTab(EPMaddon.homepageURL) : Cc["@mozilla.org/messenger;1"].createInstance(Ci.nsIMessenger).launchExternalURL(EPMaddon.homepageURL);
							if (event.button == 2 || (event.button == 0 && event.ctrlKey))
								AddonManager.getAddonByID(EPMaddon.id, function(addon) {
									addon.userDisabled = !addon.userDisabled;
									if (addon.operationsRequiringRestart && !EPMShowRestart)
										Application.restart();
									ExtensionPreferencesMenu.setup();
								});
						}
					});
					if (!EPMaddon.optionsURL)
						item.setAttribute("disabled", true);
					if (!EPMaddon.isActive)
						item.setAttribute("EPMisDisabled", true);
					if (EPMaddon.pendingOperations == 1)
						item.setAttribute("EPMtoBeToggled", true);
					if (EPMaddon.pendingOperations == 2)
						item.setAttribute("EPMtoBeToggled", false);

					if (EPMshowIcons) {
						item.setAttribute("class", "menuitem-iconic");
						MenuIconURL = EPMaddon.iconURL || 'chrome://mozapps/skin/extensions/extensionGeneric-16.png';
						item.setAttribute("style", "list-style-image: url(" + MenuIconURL + ")");
					}
					else
						item.setAttribute("class", "menuitem");

					if (EPMBlackListArray)
						for (let i = 0; i < EPMBlackListArray.length; i++)
							if (EPMBlackListArray[i] == EPMaddon.name.toLowerCase()) {
								EPMShowIt = false;
								break;
							}
							else
								EPMShowIt = true;

					if (EPMShowIt)
						aParent.appendChild(item);
				}
			});

			Cc["@mozilla.org/xul/xul-sort-service;1"].getService(Ci.nsIXULSortService).sort(aParent, "label", "ascending");

			if (EPMShowRestart) {
				aParent.appendChild(document.createElement("menuseparator"));

				item = document.createElement("menuitem");
				item.setAttribute("label", EPMrestartLabel);
				item.addEventListener("command", function() { Application.restart() });

				if (EPMshowIcons) {
					item.setAttribute("class", "menuitem-iconic");
					item.setAttribute("style", "list-style-image: url(chrome://prefsmenu/skin/restart.png)");
				}
				else
					item.setAttribute("class", "menuitem");

				aParent.appendChild(item);
			}
		});
	},

	openAddonsManager: function() {
		(window['BrowserOpenAddonsMgr'] || window['openAddonsMgr'] || window['toEM'])((Services.prefs.getBoolPref("extensions.ExtensionPreferencesMenu.OpenExtensionsPage")) ? 'addons://list/extension' : '');
	},

	shutdown: function() {
		window.removeEventListener('unload', function EPMunload() { ExtensionPreferencesMenu.shutdown() });
		AddonManager.removeAddonListener(this);
		this._branch.removeObserver("", this);
		window.removeEventListener('customizationchange', function EPMsetup() { ExtensionPreferencesMenu.setup() });
	}
};

window.addEventListener('load', function EPMload() { ExtensionPreferencesMenu.startup() });
window.addEventListener('unload', function EPMunload() { ExtensionPreferencesMenu.shutdown() });
